#!/usr/bin/perl
#このファイルの内容については、パブリックドメインとします

use warnings;
use strict;
use utf8;

#KueChip2.pmをロード
use lib ".";
use KueChip2;

#アセンブリのコードをリストにロード
my @src_list;
my $src_handle;
open($src_handle, "<", "sample.s");
while(<$src_handle>){
    push @src_list, $_;
}
close($src_handle);

#Kue-Chip2のエミュレータオブジェクトを作成
my $m = KueChip2->new();

#sample.sからロードしたコードをアセンブリングして、
#エミュレータのコード領域に格納
$m->asm(@src_list);

#入力値をメモリに格納
$m->set_value("(0)", 6);
$m->set_value("(1)", 3);

#HLT命令が現れるまで実行する
$m->do();

#メモリをダンプしてみる
$m->dump();

#得られた答えを出力
print($m->get_value("(2)") . "\n");

